/*
 * $Id: sys_io.S,v 1.1.1.1 1996/06/30 15:50:54 mtp Exp $
 ****************************************************************************
 *    
 *  COPYRIGHT NOTICE
 *    
 *  Copyright (C) 1995, 1996 Michael T. Peterson
 *  This file is part of the PCthreads (tm) multithreading library
 *  package.
 *    
 *  The source files and libraries constituting the PCthreads (tm) package
 *  are free software; you can redistribute them and/or modify them under
 *  the terms of the GNU Library General Public License as published by the Free
 *  Software Foundation; either version 2 of the License, or (at your
 *  option) any later version.
 *    
 *  The PCthreads (tm) package is distributed in the hope that it will
 *  be useful, but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 *  Library General Public License for more details.
 *    
 *  You should have received a copy of the GNU Library General Public
 *  License along with this library (see the file COPYING.LIB); if not,
 *  write to the Free Software Foundation, Inc., 675 Mass Ave, Cambridge,
 *  MA 02139, USA.
 *    
 *  To report bugs, bug fixes, or provide feedback you may contact the
 *  author, Michael T. Peterson, at either of the two email addresses listed
 *  below:
 *    
 *             mtp@big.aa.net (preferred)
 *             mtp@zso.dec.com
 *    
 *    
 *  Michael T. Peterson
 *  Issaquah, WA
 *  29 January, 1996
 ****************************************************************************
 * $Log: sys_io.S,v $
 * Revision 1.1.1.1  1996/06/30 15:50:54  mtp
 * DCE threads for Linux V1.0
 *
 ****************************************************************************
 */
.file  "sys_io.S"
#include <sys/syscall.h>

.global    _errno

.text
.globl     _sys_io_read
.globl     _sys_io_write

   .align 4
_sys_io_error:
   movl    %eax, _errno
   movl    $-1, %eax
   ret

   .align 4
_sys_io_read:
   push    %ebx
   mov     8(%esp), %ebx
   mov     12(%esp), %ecx
   mov     16(%esp), %edx
   movl    $SYS_read, %eax
   int     $0x80
   pop     %ebx
   testl   %eax, %eax
   jl     _sys_io_error
   ret

   .align 4
_sys_io_write:
   push    %ebx
   mov     8(%esp), %ebx
   mov     12(%esp), %ecx
   mov     16(%esp), %edx
   movl    $SYS_write, %eax
   int     $0x80
   pop     %ebx
   testl   %eax, %eax
   jl     _sys_io_error
   ret
